diff --git a/package/kernel/mac80211/patches/rt2x00/985-rt2x00-add-rxiq-calibration.patch b/package/kernel/mac80211/patches/rt2x00/985-rt2x00-add-rxiq-calibration.patch
index 9603d94f57ac..63cca526c294 100644
--- a/package/kernel/mac80211/patches/rt2x00/985-rt2x00-add-rxiq-calibration.patch
+++ b/package/kernel/mac80211/patches/rt2x00/985-rt2x00-add-rxiq-calibration.patch
@@ -1,6 +1,6 @@
 --- a/drivers/net/wireless/ralink/rt2x00/rt2800lib.c
 +++ b/drivers/net/wireless/ralink/rt2x00/rt2800lib.c
-@@ -8693,6 +8693,386 @@ void rt2800_rxdcoc_calibration(struct rt
+@@ -8693,6 +8693,385 @@ void rt2800_rxdcoc_calibration(struct rt
  }
  EXPORT_SYMBOL_GPL(rt2800_rxdcoc_calibration);
  
@@ -18,7 +18,6 @@
 +
 +	return root;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_do_sqrt_accumulation);
 +
 +void rt2800_rxiq_calibration(struct rt2x00_dev *rt2x00dev) {
 +	u8 rfb0r1, rfb0r2, rfb0r42;
@@ -387,7 +386,7 @@
  static void rt2800_bbp_core_soft_reset(struct rt2x00_dev *rt2x00dev,
  				       bool set_bw, bool is_ht40)
  {
-@@ -9305,6 +9685,7 @@ static void rt2800_init_rfcsr_6352(struc
+@@ -9305,6 +9684,7 @@ static void rt2800_init_rfcsr_6352(struc
  	rt2800_rxdcoc_calibration(rt2x00dev);
  	rt2800_bw_filter_calibration(rt2x00dev, true);
  	rt2800_bw_filter_calibration(rt2x00dev, false);
diff --git a/package/kernel/mac80211/patches/rt2x00/986-rt2x00-add-TX-LOFT-calibration.patch b/package/kernel/mac80211/patches/rt2x00/986-rt2x00-add-TX-LOFT-calibration.patch
index e0bf00deb6f7..1a18f13f8eaa 100644
--- a/package/kernel/mac80211/patches/rt2x00/986-rt2x00-add-TX-LOFT-calibration.patch
+++ b/package/kernel/mac80211/patches/rt2x00/986-rt2x00-add-TX-LOFT-calibration.patch
@@ -1,6 +1,6 @@
 --- a/drivers/net/wireless/ralink/rt2x00/rt2800lib.c
 +++ b/drivers/net/wireless/ralink/rt2x00/rt2800lib.c
-@@ -9073,6 +9073,954 @@ restore_value:
+@@ -9072,6 +9072,944 @@ restore_value:
  }
  EXPORT_SYMBOL_GPL(rt2800_rxiq_calibration);
  
@@ -121,7 +121,6 @@
 +
 +	return;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_rf_configstore);
 +
 +static void rt2800_rf_configrecover(struct rt2x00_dev *rt2x00dev, rf_reg_pair rf_record[][13])
 +{
@@ -140,7 +139,6 @@
 +
 +	return;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_rf_configrecover);
 +
 +static void rt2800_setbbptonegenerator(struct rt2x00_dev *rt2x00dev)
 +{
@@ -160,9 +158,8 @@
 +
 +	return;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_setbbptonegenerator);
 +
-+u32 rt2800_do_fft_accumulation(struct rt2x00_dev *rt2x00dev, u8 tidx, u8 read_neg)
++static u32 rt2800_do_fft_accumulation(struct rt2x00_dev *rt2x00dev, u8 tidx, u8 read_neg)
 +{
 +	u32 macvalue = 0;
 +	int fftout_i = 0, fftout_q = 0;
@@ -220,9 +217,8 @@
 +
 +	return pint;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_do_fft_accumulation);
 +
-+u32 rt2800_read_fft_accumulation(struct rt2x00_dev *rt2x00dev, u8 tidx) {
++static u32 rt2800_read_fft_accumulation(struct rt2x00_dev *rt2x00dev, u8 tidx) {
 +	u32 macvalue = 0;
 +	int fftout_i = 0, fftout_q = 0;
 +	u32 ptmp=0, pint = 0;
@@ -245,7 +241,6 @@
 +
 +	return pint;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_read_fft_accumulation);
 +
 +static void rt2800_write_dc(struct rt2x00_dev *rt2x00dev, u8 ch_idx, u8 alc, u8 iorq, u8 dc)
 +{
@@ -266,7 +261,6 @@
 +
 +	return;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_write_dc);
 +
 +static void rt2800_loft_search(struct rt2x00_dev *rt2x00dev, u8 ch_idx, u8 alc_idx, u8 dc_result[][RF_ALC_NUM][2])
 +{
@@ -324,7 +318,6 @@
 +
 +	return;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_loft_search);
 +
 +static void rt2800_iq_search(struct rt2x00_dev *rt2x00dev, u8 ch_idx, u8 *ges, u8 *pes)
 +{
@@ -450,7 +443,6 @@
 +
 +	return;
 +}
-+EXPORT_SYMBOL_GPL(rt2800_iq_search);
 +
 +static void rt2800_rf_aux_tx0_loopback(struct rt2x00_dev *rt2x00dev)
 +{
@@ -468,7 +460,6 @@
 +	rt2800_rfcsr_write_bank(rt2x00dev, 5, 19, 0xa2);
 +	rt2800_rfcsr_write_bank(rt2x00dev, 5, 20, 0x20);
 +}
-+EXPORT_SYMBOL_GPL(rt2800_rf_aux_tx0_loopback);
 +
 +static void rt2800_rf_aux_tx1_loopback(struct rt2x00_dev *rt2x00dev)
 +{
@@ -486,7 +477,6 @@
 +	rt2800_rfcsr_write_bank(rt2x00dev, 7, 19, 0xa2);
 +	rt2800_rfcsr_write_bank(rt2x00dev, 7, 20, 0x20);
 +}
-+EXPORT_SYMBOL_GPL(rt2800_rf_aux_tx1_loopback);
 +
 +void rt2800_loft_iq_calibration(struct rt2x00_dev *rt2x00dev)
 +{
@@ -955,7 +945,7 @@
  static void rt2800_bbp_core_soft_reset(struct rt2x00_dev *rt2x00dev,
  				       bool set_bw, bool is_ht40)
  {
-@@ -9685,6 +10633,7 @@ static void rt2800_init_rfcsr_6352(struc
+@@ -9684,6 +10622,7 @@ static void rt2800_init_rfcsr_6352(struc
  	rt2800_rxdcoc_calibration(rt2x00dev);
  	rt2800_bw_filter_calibration(rt2x00dev, true);
  	rt2800_bw_filter_calibration(rt2x00dev, false);